 '
'  Jrgen Huhn 2009       PBWin-Compiler 9.10
'  JuHuhn@Hotmail.com
'
'  JH_glGetMessage.inc  01.2009
'
'
'----====xxxxxxxxxxxxxxxxxxxxxxxxx-JH_StaticFunctions.inc-xxxxxxxxxxxxxxxxxxxxxxxx====----


#IF NOT %DEF(%JH_glGetMessage_INC)     '//  #INCLUDE ONCE "JH_glGetMessage.inc"
    %JH_glGetMessage_INC = 1

'------====xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx====------

%LOCALE_USER_DEFAULT               = &H0000
%LOCALE_SYSTEM_DEFAULT             = &H0800&
%LOCALE_ILANGUAGE                  = &H00000001   ' language id
%LOCALE_SLANGUAGE                  = &H00000002   ' localized name of language
%LOCALE_SENGLANGUAGE               = &H00001001   ' English name of language

'OGL Font
%WGL_FONT_LINES      = 0
%WGL_FONT_POLYGONS   = 1
%FF_DONTCARE         = 0    ' Don't care or don't know.
%ANSI_CHARSET        = 0
%OUT_DEFAULT_PRECIS  = 0
%CLIP_DEFAULT_PRECIS = 0
%DEFAULT_QUALITY     = 0
%DEFAULT_PITCH       = 0

%NULL                = 0
%FALSE               = 0
%TRUE                = 1

'/* StringNames */
%GL_VENDOR                         = &H1F00???
%GL_RENDERER                       = &H1F01???
%GL_VERSION                        = &H1F02???
%GL_EXTENSIONS                     = &H1F03???
'/* ErrorCode */
%GL_NO_ERROR                       = 0???
%GL_INVALID_ENUM                   = &H0500???
%GL_INVALID_VALUE                  = &H0501???
%GL_INVALID_OPERATION              = &H0502???
%GL_STACK_OVERFLOW                 = &H0503???
%GL_STACK_UNDERFLOW                = &H0504???
%GL_OUT_OF_MEMORY                  = &H0505???

%SND_NOWAIT                     = &H2000      ' don't wait if the driver is busy

' OpenGL
%GL_TRUE                        = %TRUE
%GL_FALSE                       = %FALSE

%GL_UNSIGNED_BYTE               = &h1401&
%GL_QUADS                       = &h0007&
%GL_COLOR_BUFFER_BIT            = &h4000&
%GL_DEPTH_BUFFER_BIT            = &h0100&
%GL_MATRIX_MODE                 = &h0BA0&
%GL_MODELVIEW                   = &h1700&
%GL_PROJECTION                  = &h1701&
%GL_SMOOTH                      = &h1D01&
%GL_DEPTH_TEST                  = &h0B71&
%GL_SRC_ALPHA                   = &h0302&
%GL_ONE                         = &h0001&
%GL_BLEND                       = &h0BE2&
%GL_LINEAR                      = &h2601&
%GL_PERSPECTIVE_CORRECTION_HINT = &h0C50&
%GL_POINT_SMOOTH_HINT           = &H0C51&
%GL_LINE_SMOOTH_HINT            = &H0C52&
%GL_POLYGON_SMOOTH_HINT         = &H0C53&
%GL_FOG_HINT                    = &H0C54&
%GL_NICEST                      = &h1102&
%GL_DONT_CARE                   = &H1100&
%GL_FASTEST                     = &H1101&
%GL_TEXTURE_2D                  = &h0DE1&
%GL_TEXTURE_MAG_FILTER          = &h2800&
%GL_TEXTURE_MIN_FILTER          = &h2801&
%GL_LUMINANCE                   = &h1909&
%GL_RGB                         = &H1907&
%GL_RGBA                        = &H1908&
%GL_TEXTURE                     = &H1702&
%GL_LESS                        = &H0201&
%GL_LIGHTING                    = &H0B50&
%GL_GREATER                     = &H0204&
%GL_LEQUAL                      = &H0203&
%GL_COMPILE                     = &H1300&
%GL_TRIANGLE_FAN                = &H0006&
%GL_TRIANGLE_STRIP              = &H0005&
%GL_QUAD_STRIP                  = &H0008???
%GL_POLYGON                     = &H0009???
%GL_ALPHA_TEST                  = &H0BC0&
%GL_DST_ALPHA                   = &H0304???
%GL_ONE_MINUS_DST_ALPHA         = &H0305???
%GL_FRONT_AND_BACK              = &H0408???
%GL_SPECULAR                    = &H1202???
%GL_POSITION                    = &H1203???
%GL_EMISSION                    = &H1600???
%GL_SHININESS                   = &H1601???
%GL_AMBIENT_AND_DIFFUSE         = &H1602???
%GL_COLOR_INDEXES               = &H1603???
%GL_COLOR_MATERIAL              = &H0B57???
%GL_AMBIENT                     = &H1200
%GL_DIFFUSE                     = &H1201
'/* Light
%GL_LIGHT0                      = &H4000
%GL_LIGHT1                      = &H4001

TYPE RECT
    nLeft AS LONG
    nTop AS LONG
    nRight AS LONG
    nBottom AS LONG
END TYPE


TYPE LOGFONT
  lfHeight AS LONG
  lfWidth AS LONG
  lfEscapement AS LONG
  lfOrientation AS LONG
  lfWeight AS LONG
  lfItalic AS BYTE
  lfUnderline AS BYTE
  lfStrikeOut AS BYTE
  lfCharSet AS BYTE
  lfOutPrecision AS BYTE
  lfClipPrecision AS BYTE
  lfQuality AS BYTE
  lfPitchAndFamily AS BYTE
  lfFaceName AS ASCIIZ * 32
END TYPE

TYPE ENUMLOGFONT
  elfLogFont AS LOGFONT
  elfFullName AS ASCIIZ * 64
  elfStyle AS ASCIIZ *32
END TYPE

TYPE NEWTEXTMETRIC
  tmHeight AS LONG
  tmAscent AS LONG
  tmDescent AS LONG
  tmInternalLeading AS LONG
  tmExternalLeading AS LONG
  tmAveCharWidth AS LONG
  tmMaxCharWidth AS LONG
  tmWeight AS LONG
  tmOverhang AS LONG
  tmDigitizedAspectX AS LONG
  tmDigitizedAspectY AS LONG
  tmFirstChar AS BYTE
  tmLastChar AS BYTE
  tmDefaultChar AS BYTE
  tmBreakChar AS BYTE
  tmItalic AS BYTE
  tmUnderlined AS BYTE
  tmStruckOut AS BYTE
  tmPitchAndFamily AS BYTE
  tmCharSet AS BYTE
  ntmFlags AS DWORD
  ntmSizeEM AS DWORD
  ntmCellHeight AS DWORD
  ntmAveWidth AS DWORD
END TYPE

TYPE POINTFLOAT                    '  User Type - e.g.: pf as Pointfloat, Members: pf.X, pf.y
  x AS SINGLE
  y AS SINGLE
END TYPE

TYPE GLYPHMETRICSFLOAT
  gmfptGlyphOrigin AS POINTFLOAT
  gmfBlackBoxX AS SINGLE
  gmfBlackBoxY AS SINGLE
  gmfCellIncX AS SINGLE
  gmfCellIncY AS SINGLE
END TYPE

TYPE MatrixLetters
  Letter AS LONG    ' ID
  active AS SINGLE  ' Active count
  Fade   AS SINGLE  ' Color Fade
  a AS SINGLE       ' Alpha value
  r AS SINGLE       ' Red value
  g AS SINGLE       ' Green value
  b AS SINGLE       ' Blue value
  x AS SINGLE       ' X Position
  y AS SINGLE       ' Y Position
  z AS SINGLE       ' Z Position
END TYPE

TYPE tagMSG
  hwnd AS DWORD
  message AS DWORD
  wParam AS LONG
  lParam AS LONG
  time AS DWORD
  pt AS POINTAPI
END TYPE

DECLARE FUNCTION GetLastError LIB "KERNEL32.DLL" ALIAS "GetLastError" () AS DWORD
DECLARE FUNCTION GetLocaleInfo LIB "KERNEL32.DLL" ALIAS "GetLocaleInfoA" (BYVAL Locale AS LONG, BYVAL LCType AS LONG, lpLCData AS ASCIIZ, BYVAL cchData AS LONG) AS LONG
DECLARE FUNCTION GetClientRect LIB "USER32.DLL" ALIAS "GetClientRect" (BYVAL hwnd AS DWORD, lpRect AS RECT) AS LONG
DECLARE FUNCTION GetTickCount LIB "KERNEL32.DLL" ALIAS "GetTickCount" () AS DWORD
DECLARE FUNCTION CreateFontIndirect LIB "GDI32.DLL" ALIAS "CreateFontIndirectA" (lpLogFont AS LOGFONT) AS DWORD
DECLARE FUNCTION EnumFontFamilies LIB "GDI32.DLL" ALIAS "EnumFontFamiliesA" (BYVAL hdc AS DWORD, lpszFamily AS ASCIIZ, BYVAL lpEnumFontFamProc AS DWORD, BYVAL lParam AS LONG) AS LONG

DECLARE FUNCTION glIsList LIB "OPENGL32.DLL" ALIAS "glIsList" (BYVAL list AS DWORD) AS BYTE
DECLARE FUNCTION glGetString LIB "OPENGL32.DLL" ALIAS "glGetString" (BYVAL DWORD) AS DWORD
DECLARE FUNCTION glGetError LIB "opengl32.dll" ALIAS "glGetError" () AS DWORD
DECLARE FUNCTION wglMakeCurrent LIB "OPENGL32.DLL" ALIAS "wglMakeCurrent" (BYVAL hdc AS DWORD, BYVAL hglrc AS DWORD) AS LONG
DECLARE FUNCTION wglUseFontOutlines LIB "OPENGL32.DLL" ALIAS "wglUseFontOutlinesA" (BYVAL hdc AS DWORD, BYVAL dFirst AS DWORD, BYVAL dCount AS DWORD, BYVAL dListBase AS DWORD, BYVAL deviation AS SINGLE, BYVAL extrusion AS SINGLE, _
                 BYVAL iFormat AS LONG, BYVAL lpgmf AS DWORD) AS LONG
DECLARE SUB glBegin LIB "opengl32.dll" ALIAS "glBegin" (BYVAL LONG)
DECLARE SUB glClear LIB "opengl32.dll" ALIAS "glClear" (BYVAL DWORD)
DECLARE SUB glEnable LIB "opengl32.dll" ALIAS "glEnable" (BYVAL DWORD)
DECLARE SUB glDisable LIB "opengl32.dll" ALIAS "glDisable" (BYVAL DWORD)
DECLARE SUB glCallList LIB "opengl32.dll" ALIAS "glCallList" (BYVAL list AS DWORD)
DECLARE SUB glNewList LIB "opengl32.dll" ALIAS "glNewList" (BYVAL list AS DWORD, BYVAL MODE AS DWORD)
DECLARE SUB glEndList LIB "opengl32.dll" ALIAS "glEndList" ()
DECLARE SUB glEnd LIB "opengl32.dll" ALIAS "glEnd"
DECLARE SUB glPushMatrix LIB "opengl32.dll" ALIAS "glPushMatrix"
DECLARE SUB glLoadIdentity LIB "opengl32.dll" ALIAS "glLoadIdentity"
DECLARE SUB glClearDepth LIB "opengl32.dll" ALIAS "glClearDepth" (BYVAL DOUBLE)
DECLARE SUB glColor4ub LIB "OPENGL32.DLL" ALIAS "glColor4ub" (BYVAL red AS BYTE, BYVAL green AS BYTE, BYVAL blue AS BYTE, BYVAL alpha AS BYTE)
DECLARE SUB glScalef LIB "opengl32.dll" ALIAS "glScalef" (BYVAL x AS SINGLE, BYVAL y AS SINGLE, BYVAL z AS SINGLE)
DECLARE SUB glMaterialfv LIB "opengl32.dll" ALIAS "glMaterialfv" (BYVAL face AS DWORD, BYVAL pname AS DWORD, BYREF param AS SINGLE)
DECLARE SUB glMaterialf LIB "opengl32.dll" ALIAS "glMaterialf" (BYVAL face AS DWORD, BYVAL pname AS DWORD, BYVAL param AS SINGLE)
DECLARE SUB glColorMaterial LIB "opengl32.dll" ALIAS "glColorMaterial" (BYVAL face AS DWORD, BYVAL MODE AS DWORD)
DECLARE SUB glColor3fv LIB "OPENGL32.DLL" ALIAS "glColor3fv" (BYREF SINGLE) ' void
DECLARE SUB glColor4fv LIB "OPENGL32.DLL" ALIAS "glColor4fv" (BYREF SINGLE) ' void
DECLARE SUB gluPerspective LIB "glu32.dll" ALIAS "gluPerspective" (BYVAL fovy#, BYVAL aspect#, BYVAL zNear#, BYVAL zFar AS DOUBLE)
'------====xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx====------
DECLARE SUB glFinish LIB "OPENGL32.DLL" ALIAS "glFinish" ()
'------====xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx====------
DECLARE SUB glFlush LIB "OPENGL32.DLL" ALIAS "glFlush" ()
'------====xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx====------
DECLARE SUB glShadeModel LIB "opengl32.dll" ALIAS "glShadeModel" (BYVAL DWORD)
DECLARE SUB glMatrixMode LIB "opengl32.dll" ALIAS "glMatrixMode" (BYVAL DWORD)
DECLARE SUB glHint LIB "opengl32.dll" ALIAS "glHint" (BYVAL DWORD, BYVAL DWORD)
DECLARE SUB glBlendFunc LIB "opengl32.dll" ALIAS "glBlendFunc" (BYVAL LONG, BYVAL LONG)
DECLARE SUB glTexCoord2f LIB "opengl32.dll" ALIAS "glTexCoord2f" (BYVAL SINGLE, BYVAL SINGLE)
DECLARE SUB glTexEnvi LIB "opengl32.dll" ALIAS "glTexEnvi" (BYVAL DWORD, BYVAL DWORD, BYVAL LONG)
DECLARE SUB glVertex3f LIB "opengl32.dll" ALIAS "glVertex3f" (BYVAL SINGLE, BYVAL SINGLE, BYVAL SINGLE)
DECLARE SUB glVertex3d LIB "OPENGL32.DLL" ALIAS "glVertex3d" (BYVAL x AS DOUBLE, BYVAL y AS DOUBLE, BYVAL z AS DOUBLE)
DECLARE SUB glTranslatef LIB "opengl32.dll" ALIAS "glTranslatef" (BYVAL SINGLE, BYVAL SINGLE, BYVAL SINGLE)
DECLARE SUB glColor3f LIB "opengl32.dll" ALIAS "glColor3f" (BYVAL SINGLE, BYVAL SINGLE, BYVAL SINGLE)
DECLARE SUB glNormal3f LIB "opengl32.dll" ALIAS "glNormal3f" (BYVAL nx AS SINGLE, BYVAL ny AS SINGLE, BYVAL nz AS SINGLE)
DECLARE SUB glFrustum LIB "opengl32.dll" ALIAS "glFrustum" (BYVAL DOUBLE, BYVAL DOUBLE, BYVAL DOUBLE, BYVAL DOUBLE, BYVAL DOUBLE, BYVAL DOUBLE)
DECLARE SUB glColor4f LIB "opengl32.dll" ALIAS "glColor4f" (BYVAL SINGLE, BYVAL SINGLE, BYVAL SINGLE, BYVAL SINGLE)
DECLARE SUB glViewport LIB "opengl32.dll" ALIAS "glViewport" (BYVAL LONG, BYVAL LONG, BYVAL LONG, BYVAL LONG)
DECLARE SUB glClearColor LIB "opengl32.dll" ALIAS "glClearColor" (BYVAL SINGLE, BYVAL SINGLE, BYVAL SINGLE, BYVAL SINGLE)
DECLARE SUB glGenTextures LIB "opengl32.dll" ALIAS "glGenTextures" (BYVAL DWORD, textures AS DWORD)
DECLARE SUB glBindTexture LIB "opengl32.dll" ALIAS "glBindTexture" (BYVAL DWORD, BYVAL DWORD)
DECLARE SUB glTexParameteri LIB "opengl32.dll" ALIAS "glTexParameteri" (BYVAL DWORD, BYVAL DWORD, BYVAL LONG)
DECLARE SUB glTexImage2D LIB "opengl32.dll" ALIAS "glTexImage2D" (BYVAL DWORD, BYVAL LONG, BYVAL LONG, BYVAL LONG, BYVAL LONG, BYVAL LONG, BYVAL DWORD, BYVAL DWORD, npixels AS ANY)
DECLARE SUB glDeleteTextures LIB "opengl32.dll" ALIAS "glDeleteTextures" (BYVAL LONG, textures AS DWORD)
DECLARE SUB glRotatef LIB "OPENGL32.DLL" ALIAS "glRotatef" (BYVAL angle AS SINGLE, BYVAL x AS SINGLE, BYVAL y AS SINGLE, BYVAL z AS SINGLE)
DECLARE SUB glDepthFunc LIB "OPENGL32.DLL" ALIAS "glDepthFunc" (BYVAL func AS DWORD)
DECLARE SUB glAlphaFunc LIB "OPENGL32.DLL" ALIAS "glAlphaFunc" (BYVAL func AS DWORD, BYVAL ref AS SINGLE)

' -- Advanced feature to keep vertical sync on
' -- For V-Sync control we need to get address of extensions
DECLARE FUNCTION wglGetProcAddress LIB "opengl32.dll" ALIAS "wglGetProcAddress" (lpStr AS ASCIIZ) AS LONG
DECLARE FUNCTION prototype_wglSwapIntervalEXT( BYVAL number AS LONG ) AS LONG
' --
DECLARE FUNCTION JH_MatrixFunc_Color4f(BYVAL sXPos AS SINGLE, BYVAL sYPos AS SINGLE ) AS LONG
DECLARE SUB JH_Matrix_Color4f(BYVAL sXPos AS SINGLE, BYVAL sYPos AS SINGLE)
DECLARE SUB JH_MatrixPoint_Color4f(BYVAL sXYPos AS SINGLE)
DECLARE FUNCTION JH_MatrixPoint_Color4fFunc (BYVAL sXYPos AS SINGLE) AS LONG
'------====xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx====------
' Globals Font and MatrixFont (Texture!)
'------====xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx====------
GLOBAL Inf()  AS GLYPHMETRICSFLOAT  ' Array for Characters of Font
GLOBAL MLetter() AS MatrixLetters   ' Array for single Letters of MatrixFont (Texture!)
GLOBAL LetterTexHndl AS DWORD       ' MLetter Texture handle
GLOBAL TextureHandle AS DWORD       ' ACTIVE Texture handle
GLOBAL nValue AS LONG               ' Signal Level from Music
'------====xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx====------

'------====xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx====--------
'                          FUNCTION JH_GetLanguageA() AS STRING
'------====xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx====--------
' Retrieve Locale Language as a String
'
' E.g.:                        - Multilanguage -
'
' Select Case JH_GetLanguageA()
'  CASE "GERMAN"
     'Code
'  CASE "FRENCH"
     'Code
'  CASE ELSE  <-- using English for all other
     'Code
' END SELECT
'-----====xxxxxxxxxxxxxxxxxxxxxxxx-JH_GetLanguageA()-xxxxxxxxxxxxxxxxxxxxxxxxx====----
'
FUNCTION JH_GetLanguageA() AS STRING
    LOCAL sLang AS STRING, nLen AS LONG
     nLen = GetLocaleInfo(%LOCALE_USER_DEFAULT, %LOCALE_SENGLANGUAGE,BYVAL %NULL, BYVAL %NULL)
   '
     sLang = SPACE$(nLen-1)
     CALL GetLocaleInfo(%LOCALE_USER_DEFAULT, %LOCALE_SENGLANGUAGE, BYVAL STRPTR(sLang), nLen)
   ' Returned String is always upper Case (UCASE)...
    FUNCTION = TRIM$(UCASE$(sLang))
END FUNCTION
'-----====xxxxxxxxxxxxxxxxxxxxxxxx-JH_GetLanguageA()-xxxxxxxxxxxxxxxxxxxxxxxxx====----
'
'-----====xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx====----
'
'----====xxxxxxxxxxxxxxxxxxxxxxx-JH_GLGetGLErrorString-xxxxxxxxxxxxxxxxxxxxxxxx====----
'                                  - Multilanguage -
'----====xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx====----
' Error codes:                  E.g.: Str = JH_GLGetErrorString(glGetError())
'   %GL_INVALID_ENUM
'   %GL_INVALID_VALUE
'   %GL_INVALID_OPERATION
'   %GL_STACK_OVERFLOW
'   %GL_STACK_UNDERFLOW
'   %GL_OUT_OF_MEMORY
'----====xxxxxxxxxxxxxxxxxx-JH_GLGetGLErrorString_Eng-xxxxxxxxxxxxxxxxxxxxx====----
'
FUNCTION JH_GLGetErrorString_Eng(BYVAL dwGLECode AS DWORD) AS STRING
'
    SELECT CASE dwGLECode
       CASE %GL_NO_ERROR           : FUNCTION = "NO ERROR"
       CASE %GL_INVALID_ENUM       : FUNCTION = "INVALID ENUMERATION"
       CASE %GL_INVALID_VALUE      : FUNCTION = "INVALID VALUE"
       CASE %GL_INVALID_OPERATION  : FUNCTION = "INVALID OPERATION"
       CASE %GL_STACK_OVERFLOW     : FUNCTION = "Memory: STACK OVERFLOW"
       CASE %GL_STACK_UNDERFLOW    : FUNCTION = "Memory: STACK UNDERFLOW"
       CASE %GL_OUT_OF_MEMORY      : FUNCTION = "OUT_OF_MEMORY"
       CASE ELSE                   : FUNCTION = "UNKNOWN ERROR"
    END SELECT
'
END FUNCTION
'
'----====xxxxxxxxxxxxxxxxxxx-JH_GLGetGLErrorString_Eng-xxxxxxxxxxxxxxxxxxxxx====----
'
'----====xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx====----
'
'----====xxxxxxxxxxxxxxxxxxx-JH_GLGetGLErrorString_Ger-xxxxxxxxxxxxxxxxxxxxx====----
'
FUNCTION JH_GLGetErrorString_Ger(BYVAL dwGLECode AS DWORD) AS STRING
'
    SELECT CASE dwGLECode
       CASE %GL_NO_ERROR           : FUNCTION = "Kein Fehler"
       CASE %GL_INVALID_ENUM       : FUNCTION = "Ungltige Enumeration"
       CASE %GL_INVALID_VALUE      : FUNCTION = "Ungltiger bergabewert"
       CASE %GL_INVALID_OPERATION  : FUNCTION = "Ungltige Operation"
       CASE %GL_STACK_OVERFLOW     : FUNCTION = "Speicher: Stapelberlauf"
       CASE %GL_STACK_UNDERFLOW    : FUNCTION = "Speicher: Stapel leer gelaufen"
       CASE %GL_OUT_OF_MEMORY      : FUNCTION = "Ungengender Arbeitspeicher"
       CASE ELSE                   : FUNCTION = "Unbekannter Fehler"     '  "Erreur inconnu"
    END SELECT
'
END FUNCTION
'
'----====xxxxxxxxxxxxxxxxxxxx-JH_GLGetGLErrorString_Ger-xxxxxxxxxxxxxxxxxxxx====----
'
'----====xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx====----
'
'----====xxxxxxxxxxxxxxxxxxxxxx-JH_GLGetGLErrorString-xxxxxxxxxxxxxxxxxxxxxx====----
'
FUNCTION JH_GLGetErrorString(BYVAL dwGLECode AS DWORD) AS STRING
       SELECT CASE JH_GetLanguageA()
          CASE "FRENCH"  : FUNCTION = JH_GLGetErrorString_Eng(dwGLECode)
          CASE "GERMAN"  : FUNCTION = JH_GLGetErrorString_Ger(dwGLECode)
          CASE ELSE      : FUNCTION = JH_GLGetErrorString_Eng(dwGLECode)
       END SELECT
END FUNCTION
'
'----====xxxxxxxxxxxxxxxxxxxxxx-JH_GLGetGLErrorString-xxxxxxxxxxxxxxxxxxxxxx====----
'
'----====xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx====----
'
'----====xxxxxxxxxxxxxxxxxxxxxxxxx-JH_GLGetString-xxxxxxxxxxxxxxxxxxxxxxxxxx====----
'
'  Returns a string describing some aspect of the current OpenGL connection.
'  Parameter:
'  dwName : One of the following symbolic constants:
'   %GL_VENDOR
'      Returns the company responsible for this OpenGL implementation.
'      This name does not change from release to release.
'   %GL_RENDERER
'      Returns the name of the renderer. This name is typically specific to a
'      particular configuration of a hardware platform. It does not change from release
'      to release.
'   %GL_VERSION
'      Returns a version or release number.
'   %GL_EXTENSIONS
'      Returns a space-separated list of supported extensions to OpenGL.
'  Error codes:
'   %GL_INVALID_ENUM
'      dwName was not an accepted value.
'   %GL_INVALID_OPERATION
'      glGetString was called between a call to glBegin and the corresponding call to glEnd.
'----====xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx====----
'
FUNCTION JH_GLGetString (BYVAL dwName AS DWORD) AS STRING
'
    LOCAL nLen AS LONG, GL_ERROR AS DWORD
    LOCAL szPtr AS ASCIIZ PTR, szITxt AS ASCIIZ * 260
'
      szPtr = glGetString(dwName)
      GL_ERROR = glGetError()
      szITxt = @szPtr
      nLen = LEN(szITxt)
      IF nLen > 0 AND GL_ERROR = %GL_NO_ERROR THEN
         FUNCTION = szITxt
         EXIT FUNCTION
      END IF
'
    FUNCTION = JH_GLGetErrorString(GL_ERROR)
'
END FUNCTION
'
'----====xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx====----
'                             "OpenGL Version: "
'----====xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx====----
'  return`s a String: VERSION,VENDOR,RENDERER and number of available Parts AS LONG
'----====xxxxxxxxxxxxxxxxxxxxxxx-JH_GetglVersionInfo-xxxxxxxxxxxxxxxxxxxxxxxx====----
'
FUNCTION JH_GetglVersionInfo (BYREF szOTxt AS ASCIIZ * 255) AS LONG
'
   LOCAL szABuffer, szBBuffer AS ASCIIZ * 255, nRet AS LONG
'
      szABuffer = JH_GLGetString(%GL_VERSION)
      szBBuffer = JH_GLGetString(%GL_VENDOR)
      IF LEN(szABuffer) THEN
         nRet = 1
         szABuffer = "OpenGL V." &  szABuffer + "," + szBBuffer
      ELSE
         szABuffer = szBBuffer
      END IF
      szBBuffer = JH_GLGetString(%GL_RENDERER)
      IF LEN(szABuffer) THEN
         nRet = nRet + 1
         szABuffer = szABuffer + "," + szBBuffer
      ELSE
         szABuffer = szBBuffer
      END IF
      IF LEN(szABuffer) THEN nRet = nRet + 1
      szOTxt = szABuffer
    FUNCTION = nRet
END FUNCTION
'
'----====xxxxxxxxxxxxxxxxxxxxxxx-JH_GetglVersionInfo-xxxxxxxxxxxxxxxxxxxxxxx====----
'
'----====xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx====----
'
'----====xxxxxxxxxxxxxxxxxxxxxx-JH_GetglVersionArray-xxxxxxxxxxxxxxxxxxxxxxx====----
'  return`s a StringArray(): VERSION,VENDOR,RENDERER and number of available Parts AS LONG
'----====xxxxxxxxxxxxxxxxxxxxxx-JH_GetglVersionArray-xxxxxxxxxxxxxxxxxxxxxxx====----
'
FUNCTION JH_GetglVersionArray(BYREF glVersionArray() AS STRING) AS LONG
'
   LOCAL szABuffer AS ASCIIZ * 255, nCount, VLen AS LONG
'
   nCount=JH_GetglVersionInfo(szABuffer)
   IF nCount > 0 THEN
      FOR VLen=0 TO nCount-1
         IF szABuffer = "" THEN EXIT FOR
         REDIM PRESERVE glVersionArray(VLen)
         glVersionArray(VLen) = EXTRACT$(szABuffer, ",")
         szABuffer = REMAIN$(szABuffer, ",")
      NEXT
   END IF
   FUNCTION = nCount
END FUNCTION
'
'----====xxxxxxxxxxxxxxxxxxxxxx-JH_GetglVersionArray-xxxxxxxxxxxxxxxxxxxxxxx====----
'
'----====xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx====----
'
'----====xxxxxxxxxxxxxxxxxxxxxxxxxx-JH_ColorInit()-xxxxxxxxxxxxxxxxxxxxxxxxx====----
'
SUB JH_ColorInit()

   DIM gColor (0 TO 33, 0 TO 2) AS GLOBAL LONG
   gColor ( 0, 0) = 175 : gColor ( 0, 1) = 9   : gColor ( 0, 2) = 155
   gColor ( 1, 0) = 0   : gColor ( 1, 1) = 32  : gColor ( 1, 2) = 252
   gColor ( 2, 0) = 0   : gColor ( 2, 1) = 44  : gColor ( 2, 2) = 223
   gColor ( 3, 0) = 0   : gColor ( 3, 1) = 67  : gColor ( 3, 2) = 210
   gColor ( 4, 0) = 0   : gColor ( 4, 1) = 89  : gColor ( 4, 2) = 187
   gColor ( 5, 0) = 0   : gColor ( 5, 1) = 112 : gColor ( 5, 2) = 164
   gColor ( 6, 0) = 0   : gColor ( 6, 1) = 135 : gColor ( 6, 2) = 142
   gColor ( 7, 0) = 0   : gColor ( 7, 1) = 159 : gColor ( 7, 2) = 117
   gColor ( 8, 0) = 0   : gColor ( 8, 1) = 183 : gColor ( 8, 2) = 88
   gColor ( 9, 0) = 0   : gColor ( 9, 1) = 207 : gColor ( 9, 2) = 58
   gColor (10, 0) = 0   : gColor (10, 1) = 231 : gColor (10, 2) = 29
   gColor (11, 0) = 26  : gColor (11, 1) = 234 : gColor (11, 2) = 26
   gColor (12, 0) = 52  : gColor (12, 1) = 237 : gColor (12, 2) = 23
   gColor (13, 0) = 79  : gColor (13, 1) = 240 : gColor (13, 2) = 20
   gColor (14, 0) = 105 : gColor (14, 1) = 243 : gColor (14, 2) = 17
   gColor (15, 0) = 126 : gColor (15, 1) = 245 : gColor (15, 2) = 14
   gColor (16, 0) = 147 : gColor (16, 1) = 248 : gColor (16, 2) = 11
   gColor (17, 0) = 168 : gColor (17, 1) = 250 : gColor (17, 2) = 8
   gColor (18, 0) = 189 : gColor (18, 1) = 253 : gColor (18, 2) = 5
   gColor (19, 0) = 210 : gColor (19, 1) = 255 : gColor (19, 2) = 3
   gColor (20, 0) = 223 : gColor (20, 1) = 255 : gColor (20, 2) = 0
   gColor (21, 0) = 235 : gColor (21, 1) = 255 : gColor (21, 2) = 0
   gColor (22, 0) = 245 : gColor (22, 1) = 251 : gColor (22, 2) = 0
   gColor (23, 0) = 255 : gColor (23, 1) = 235 : gColor (23, 2) = 0
   gColor (24, 0) = 255 : gColor (24, 1) = 215 : gColor (24, 2) = 0
   gColor (25, 0) = 255 : gColor (25, 1) = 196 : gColor (25, 2) = 0
   gColor (26, 0) = 255 : gColor (26, 1) = 176 : gColor (26, 2) = 0
   gColor (27, 0) = 255 : gColor (27, 1) = 156 : gColor (27, 2) = 0
   gColor (28, 0) = 253 : gColor (28, 1) = 137 : gColor (28, 2) = 0
   gColor (29, 0) = 255 : gColor (29, 1) = 117 : gColor (29, 2) = 0
   gColor (30, 0) = 255 : gColor (30, 1) = 97  : gColor (30, 2) = 0
   gColor (31, 0) = 255 : gColor (31, 1) = 78  : gColor (31, 2) = 0
   gColor (32, 0) = 255 : gColor (32, 1) = 58  : gColor (32, 2) = 0
   gColor (33, 0) = 255 : gColor (33, 1) = 18  : gColor (33, 2) = 2
END SUB
'
'----====xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx====----
'
FUNCTION JH_LevelColr(BYVAL nLevel AS LONG) AS LONG
    LOCAL nColor AS LONG
    LOCAL R, G, B AS LONG ' Byte

    nLevel = nLevel + 1: IF nLevel > 33 THEN nLevel = 33
    nColor = 0
    IF nLevel > 0 THEN
       R = gColor((nLevel), 0)
       G = gColor((nLevel), 1)
       B = gColor((nLevel), 2)
       nColor = RGB(R, G, B)
    END IF

    FUNCTION = nColor
END FUNCTION
'
'----====xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx====----
'
'----====xxxxxxxxxxxxxxxxxxxxxxxxxxxx-JH_MakeGLFont-xxxxxxxxxxxxxxxxxxxxxxxx====----
'
SUB JH_MakeGLFont(BYVAL hDC AS LONG, BYVAL ListBase AS DWORD, BYVAL FontName AS STRING)
  LOCAL lpLogFont AS LOGFONT
  LOCAL hFont AS LONG
  REDIM Inf(255) AS GLYPHMETRICSFLOAT

  lpLogFont.lfHeight = -20
  lpLogFont.lfWeight = 1000 '%FW_NORMAL
  lpLogFont.lfCharSet = %ANSI_CHARSET
  lpLogFont.lfOutPrecision = %OUT_DEFAULT_PRECIS
  lpLogFont.lfClipPrecision = %CLIP_DEFAULT_PRECIS
  lpLogFont.lfQuality = %DEFAULT_QUALITY
  lpLogFont.lfPitchAndFamily = %FF_DONTCARE OR %DEFAULT_PITCH
  lpLogFont.lfFaceName = FontName  ' font

  hFont = CreateFontIndirect(lpLogFont)
  hFont = SelectObject(hDC, hFont)

  CALL wglUseFontOutlines(hDC, 0, 255, ListBase, 0.0, 0.2, %WGL_FONT_POLYGONS, BYVAL VARPTR(Inf(0)))

  CALL DeleteObject(SelectObject(hDC, hFont))
END SUB
'
'----====xxxxxxxxxxxxxxxxxxxxxxxxxxxx-JH_MakeGLFont-xxxxxxxxxxxxxxxxxxxxxxxx====----
'
'----====xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx====----
'
SUB JH_DrawTextNumber(BYVAL ListBase AS DWORD, BYVAL xn AS LONG)
   LOCAL ASCTxt AS ASCIIZ * 256
   LOCAL LightOn, ALPHA_TEST_ON  AS LONG

   ASCTxt = CHR$(xn)
   CALL glIsEnabled(%GL_ALPHA_TEST) TO ALPHA_TEST_ON
   IF ALPHA_TEST_ON THEN CALL glDisable(%GL_ALPHA_TEST)
 ' Lighting off
   CALL glIsEnabled(%GL_LIGHTING) TO LightOn
   IF LightOn THEN CALL glDisable(%GL_LIGHTING)
   glScalef(1.0, 1.0, 1.0)
 ' Pushes The Display GL_LIST_BASE setting
   glPushAttrib(%GL_LIST_BIT)   ' <-- Don`t call GL_Push Command`s!!

   ' Sets the base character to 0
     CALL glListBase(ListBase)

   ' Draws the display list text
     CALL glCallLists(LEN(ASCTxt), %GL_UNSIGNED_BYTE, ASCTxt)

  ' Pops the display list bits and restores the values
  ' of the state variables saved with the last glPushAttrib call
    glPopAttrib()
    IF ALPHA_TEST_ON THEN CALL glEnable(%GL_ALPHA_TEST)
    IF LightOn THEN CALL glEnable(%GL_LIGHTING)
END SUB
'
'----====xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx====----
'
SUB JH_DrawText(BYVAL ListBase AS DWORD, BYVAL lpText AS STRING)
   LOCAL LightOn, DEPTH_TEST_ON AS LONG

   CALL glIsEnabled(%GL_DEPTH_TEST) TO DEPTH_TEST_ON
   IF DEPTH_TEST_ON THEN CALL glDisable(%GL_DEPTH_TEST)
 ' Lighting off
   CALL glIsEnabled(%GL_LIGHTING) TO LightOn
   IF LightOn THEN CALL glDisable(%GL_LIGHTING)
 '  glScalef(1.0, 1.0, 1.0)
 ' Pushes The Display GL_LIST_BASE setting
   glPushAttrib(%GL_LIST_BIT)   ' <-- Don`t call GL_Push Command`s!!

 ' Sets the base character to 0
   CALL glListBase(ListBase)

 ' Draws the display list text
   CALL glCallLists(LEN(lpText), %GL_UNSIGNED_BYTE, BYVAL STRPTR(lpText))

 ' Pops the display list bits and restores the values
 ' of the state variables saved with the last glPushAttrib call
   glPopAttrib()

   IF DEPTH_TEST_ON THEN CALL glEnable(%GL_DEPTH_TEST)
 ' Lighting on
   IF LightOn THEN CALL glEnable(%GL_LIGHTING)
END SUB
'
'----====xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx====----
'
SUB JH_DrawListNumber(BYVAL ListBase AS DWORD, BYVAL xn AS LONG)
    LOCAL ASCTxt AS ASCIIZ * 255
    LOCAL sText  AS STRING

    IF xn > 255 THEN xn = 126
    IF xn < 0 THEN
       IF nValue > 0 THEN
          xn = RND(1,55) '
       ELSE
          xn = xn/-2
       END IF
    END IF
    ASCTxt = CHR$(xn)
    sText = ASCTxt
    CALL JH_DrawText(ListBase, sText)
END SUB
'
'----====xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx====----
'
'----====xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx====----
'
'----====xxxxxxxxxxxxxxxxxxxxxxxxxxxx-JH_RGBASquare-xxxxxxxxxxxxxxxxxxxxxxxx====----
'
SUB JH_RGBASquare (BYVAL ecke AS SINGLE,BYVAL v1 AS SINGLE,BYVAL v2 AS SINGLE,BYVAL v3 AS SINGLE, _
                   BYVAL s1 AS SINGLE,BYVAL s2 AS SINGLE,BYVAL s3 AS SINGLE,BYVAL s4 AS SINGLE)
    ecke = ecke / 2
    CALL glBegin(%GL_QUADS)
      glNormal3f   0.0!, 0.0!, 1.0!
      glColor4ub   s3, s1, s2, s4
      glTexCoord2f 1.0!, 0.0! : CALL glVertex3f(ecke + v1,ecke - v2,ecke - v3) ' Bottom Right
      glColor4ub  s2, s3, s1, s4
      glTexCoord2f 1.0!, 1.0! : CALL glVertex3f(ecke + v1,ecke + v2,ecke - v3) ' Top Right
      glColor4ub   s1, s2, s3, s4
      glTexCoord2f 0.0!, 1.0! : CALL glVertex3f(ecke - v1,ecke + v2,ecke - v3) ' Top Left
      glColor4ub   s2, s1, s3, s4
      glTexCoord2f 0.0!, 0.0! : CALL glVertex3f(ecke - v1,ecke - v2,ecke - v3) ' Bottom Left
    CALL glEnd()
END SUB
'
'----====xxxxxxxxxxxxxxxxxxxxxxxxxxxx-JH_RGBASquare-xxxxxxxxxxxxxxxxxxxxxxxx====----
'
'----====xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx====----
'
'----====xxxxxxxxxxxxxxxxxxxxxxxxxxxxx-JH_Square-xxxxxxxxxxxxxxxxxxxxxxxxxxx====----
'
SUB JH_Square (BYVAL ecke AS SINGLE,BYVAL s1 AS SINGLE,BYVAL s2 AS SINGLE,BYVAL s3 AS SINGLE)
    ecke = ecke / 2
    CALL glBegin(%GL_QUADS)
      glNormal3f   0.0!, 0.0!, 1.0
      'Texture coordinates                                     'Vertex coordinates
      glTexCoord2f 1.0!, 0.0! : CALL glVertex3f( ecke + s1!, -ecke + s2!, -ecke + s3!)
      glTexCoord2f 1.0!, 1.0! : CALL glVertex3f( ecke + s1!,  ecke + s2!, -ecke + s3!)
      glTexCoord2f 0.0!, 1.0! : CALL glVertex3f(-ecke + s1!,  ecke + s2!, -ecke + s3!)
      glTexCoord2f 0.0!, 0.0! : CALL glVertex3f(-ecke + s1!, -ecke + s2!, -ecke + s3!)
    CALL glEnd()
END SUB
'
'----====xxxxxxxxxxxxxxxxxxxxxxxxxxxxx-JH_Square-xxxxxxxxxxxxxxxxxxxxxxxxxxx====----
'
'----====xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx====----
'
'----====xxxxxxxxxxxxxxxxxxxxxxxxxxx-JH_TexCoord3f-xxxxxxxxxxxxxxxxxxxxxxxxx====----
'
SUB JH_TexCoord3f(BYVAL ecke AS SINGLE,BYVAL s1 AS SINGLE,BYVAL s2 AS SINGLE,BYVAL s3 AS SINGLE)
    ecke = ecke / 2
    s3 = s3 / 2
    CALL glBegin(%GL_QUADS)
     glNormal3f   0.0!, 0.0!, 1.0!
       'Texture coordinates                                     'Vertex coordinates
        CALL glTexCoord2f((0.0625 * (s1+1)),(0.0625 * s2))      : CALL glVertex3f( ecke + s3!,-ecke + s3!, -ecke + s3!)
        CALL glTexCoord2f((0.0625 * s1), (0.0625 * s2))         : CALL glVertex3f(-ecke + s3!,-ecke + s3!, -ecke + s3!)
        CALL glTexCoord2f((0.0625 * s1), (0.0625 * (s2-1)))     : CALL glVertex3f(-ecke + s3!, ecke + s3!, -ecke + s3!)
        CALL glTexCoord2f((0.0625 * (s1+1)), (0.0625 * (s2-1))) : CALL glVertex3f( ecke + s3!, ecke + s3!, -ecke + s3!)
    glEnd()
END SUB
'
'----====xxxxxxxxxxxxxxxxxxxxxxxxxxx-JH_TexCoord3f-xxxxxxxxxxxxxxxxxxxxxxxxx====----
'
'----====xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx====----
'
'----====xxxxxxxxxxxxxxxxxxxxxxx-JH_SetTextRotationXyz-xxxxxxxxxxxxxxxxxxxxx====----
'
SUB JH_SetTextRotationXyz(BYVAL FontList AS DWORD , BYVAL sTxt AS STRING, BYVAL camera AS SINGLE _
                       , BYVAL sXPos AS SINGLE, BYVAL sYPos AS SINGLE, BYVAL sZPos AS SINGLE _
                       , BYVAL sXRot AS SINGLE, BYVAL sYRot AS SINGLE, BYVAL sZRot AS SINGLE)
    CALL glLoadIdentity()
    glTranslatef sXPos, sYPos, sZPos '  on Screen Position x - y - z
    CALL glRotatef(camera, sXRot, sYRot, sZRot) ' Rotation x - y - z
    CALL JH_DrawText(FontList, sTxt)
END SUB
'
'----====xxxxxxxxxxxxxxxxxxxxxxxx-JH_SetTextRotationXyz-xxxxxxxxxxxxxxxxxxxxxx====----
'
'----====xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx====----
'                          need JH_SetTextRotationXyz
'----====xxxxxxxxxxxxxxxxxxxxxxxx-JH_SetTextXRotationX-xxxxxxxxxxxxxxxxxxxxxx====----
'
SUB JH_SetTextXRotationX(BYVAL FontList AS DWORD , BYVAL sTxt AS STRING, BYVAL camera AS SINGLE _
                       , BYVAL sXPos AS SINGLE, BYVAL sYPos AS SINGLE, BYVAL sZPos AS SINGLE)
     CALL JH_SetTextRotationXyz(FontList, sTxt, camera, sxPos, syPos, szPos, 1.0, 0.0, 0.0)
END SUB
'
'----====xxxxxxxxxxxxxxxxxxxxxxxx-JH_SetTextXRotationX-xxxxxxxxxxxxxxxxxxxxxx====----
'
'----====xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx====----
'
'----====xxxxxxxxxxxxxxxxxxxxxxx-JH_FontItemRotationX-xxxxxxxxxxxxxxxxxxxxxx====----
'
SUB JH_FontItemRotationX(BYVAL ListBase AS DWORD, BYVAL xn AS LONG, BYVAL camera AS SINGLE _
                       , BYVAL sXPos AS SINGLE, BYVAL sYPos AS SINGLE, BYVAL sZPos AS SINGLE)
    CALL glLoadIdentity()
    glTranslatef(sXPos, sYPos, sZPos) ' on Screen Position x - y - z
    CALL glRotatef(camera, 1.0, 0.0, 0.0) ' X Rotation
    CALL JH_DrawListNumber(ListBase, xn)
END SUB
'
'----====xxxxxxxxxxxxxxxxxxxxxxx-JH_FontItemRotationX-xxxxxxxxxxxxxxxxxxxxxx====----
'
'------====xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx====------
'
'------====xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx====------
'
#ENDIF  ' #IF NOT %DEF(%JH_glGetMessage_INC)
